<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !title.isValid}">
      <label for="title">Titre</label>
      <input class="form-control" type="text" id="title" v-model.trim="title.val" @blur="clearValidity('title')"/>
      <p v-if="!title.isValid">Le titre ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !description.isValid}">
      <label for="description">Description</label>
      <textarea class="form-control" type="text" id="description" v-model.trim="description.val" @blur="clearValidity('description')"/>
    </div>
    <base-button>Ajouter</base-button>

  </form>
</template>

<script>

export default {
  emits: ['save-data'],
  data() {
    return {
      title: {
        val: '',
        isValid: true,
      },
      description: {
        val: '',
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.title.val === '') {
        this.title.isValid = false;
        this.formIsValid = false;
      }
      if (this.description.val === '') {
        this.description.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();
      console.log(this.formIsValid)
      if (!this.formIsValid) {
        return;
      }

      const formData = {
        title : this.title.val,
        description : this.description.val,
      }
      try{
        this.$emit('save-data', formData);
      }catch (e) {
        console.log(e)
      }
    },
  },
};
</script>

<style scoped>
</style>